#! /usr/bin/python3
# coding: UTF-8

#	    mdl_ttl_ext.py3	2014.9.2  kita    python3.5版
#     MDL File よりモデルタイトルを抽出するスクリプト
#     make_kensaku_db_winとセットで使用
# 使い方
#   ~/files/script/python/mdl_ttl_ext.py3  (Linux)
#   python x:\script\python\mdl_ttl_ext.py3 (win)   
	
import sys                                  # 引数処理に必要なsys moduleのimport
import binascii                             # Binary Fileを16進表記で読み込むmoduleのimport 
import codecs                               # 文字列のコード変換
import glob                                 # MDL File名取得用
import re                                   # decode
import platform                             # OS判定
import my_module3                           # is_ascii(pythn3用)

if platform.system() == 'Linux': 
  terget_dir = '/home/acad/tmp1/'            # 検索対象Dir  
  fout_name = '/home/acad/kensaku_db_files_euc'       # Data base File name
#  terget_dir = '/home/acad/files/'            # 検索対象Dir  
#  fout_name = '/home/acad/kensaku_db_files_test'       # Data base File name

elif platform.system() == 'Windows':
  terget_dir = 'c:/my_files/tmp/'                # 検索対象Dir  
  fout_name = 'c:/my_files/kensaku_db_files_win' # Data base File name
#  terget_dir = 'x:/'                            # 検索対象Dir  
#  fout_name = 'x://kensaku_db_files_win'          # Data base File name


# MDL File List 取得
file_list0 = glob.glob(terget_dir + '*.MDL')
file_list1 = glob.glob(terget_dir + '**/*.MDL')
file_list2 = glob.glob(terget_dir + '**/**/*.MDL')

file_list = file_list0 + file_list1 + file_list2
#print(file_list)

#sys.exit()

ss_ttl = '006400000065'                                
#str_ttl = ''
#f1 = codecs.open(fout_name,"a","utf-8")   # 文字コードを指定して追記モードでオープン 
f1 = codecs.open(fout_name,"w","utf-8")   # 文字コードを指定して書き込みモードでオープン 
if platform.system() == 'Linux': 
  f1 = codecs.open(fout_name,"w","euc-jp")   # 文字コードを指定して書き込みモードでオープン 
elif platform.system() == 'Windows': 
  f1 = codecs.open(fout_name,"w","shift-jis")   # 文字コードを指定して書き込みモードでオープン 

for i in range(len(file_list)):             
  if i % 100 == 0:                      # 余りが0なら
    print(i)
  fn = file_list[i].rstrip()          # NDL File name
#  print(fn)
  if my_module3.is_ascii(fn) == False:             # ascii文字以外が入っていたら処理を飛ばす
    print('File名にAscii文字以外が使われているのでスキップします')
    continue
   
  fp = open(fn,'rb')                   # 引数で指定したバイナリファイル(MDL file)をオープン
  binary_dat = fp.read()
  fp.close()
  hex_string = str(binascii.hexlify(binary_dat),'utf-8')   # 16進文字コードの「文字列」とする
  idx_ttl = hex_string.find(ss_ttl)                         # hex_string内のss_maker_codeの位置を探す
#  print(idx_ttl)
 
  # タイトル未記入
#  ttl_non = hex_string[(idx_ttl+16):(idx_ttl+20)]
#  if ttl_non == '0100':
  ttl_non = hex_string[(idx_ttl+16):(idx_ttl+20)]
  if ttl_non != '0000':
    print(fn + 'はモデルタイトルが未記入です')
    mdl_ttl = 'non'
  else: 
    # タイトルのバイト数
    no_16 = '0x' + hex_string[(idx_ttl+22):(idx_ttl+24)]
    nn = int(no_16,16) *2                       # 16進数を10進数に変換  Model Tittle文字数(byte数)
  
    mdl_ttl_str = hex_string[(idx_ttl+24):(idx_ttl+24+nn)]    # a5b8a5b0a5d7a5eca1bca5c8
    # 文字盤の'φを置換
    mdl_ttl_str = mdl_ttl_str.replace('8db1', 'a6d5')
    # <cr> を'&'に変換
    mdl_ttl_str = mdl_ttl_str.replace('0d', '26')
  
    mdl_ttl_h = bytes(mdl_ttl_str,'utf-8')                    # b'a5b8a5b0a5d7a5eca1bca5c8'
    mdl_ttl1 =(binascii.unhexlify(mdl_ttl_h))                 # b'\xa5\xb8\xa5\xb0\xa5\xd7\xa5\xec\xa1\xbc\xa5\xc8'

#   print('nn=%d _str= %s ttl_h=%s ttl1=%s' % (nn,mdl_ttl_str,mdl_ttl_h,mdl_ttl1))

    mdl_ttl = mdl_ttl1.decode('EUC-JP','ignore')    # EUC-JPの文字列 mdl_ttl0 をUnicode 文字列に戻す 'アーム'
    mdl_ttl = mdl_ttl.rstrip()                  # 行末の改行を削除 

  try:                                  # line(File名）に漢字が使われていたりした時にスキップさせる
    ss1 = '%s %s\n' % (fn, mdl_ttl)
  except UnicodeDecodeError:            # 書き込みエラーが発生したら飛ばす
    print(' %s がUnicodeDecodeErro。スキップします' % fn)
    continue

  try:
    ss = '%s %s' % (fn,mdl_ttl)
  except UnicodeEncodeError:            # 
    print(' %s がUnicodeEncodeError。スキップします' % fn)
    continue
    
  print(ss)
#  if platform.system() == 'Linux':
#    ss1.encode('euc-jp')
#  elif platform.system() == 'Windows':
#    ss1.encode('shift-jis')
    
  f1.write(ss1)                         # 書き込み
    
f1.close()
print('合計 %d 個のリストができました' % i)


